﻿CREATE VIEW [dbo].[FX_TABLAS_DIST] (REFERENCIA,CUENTA,DESCRIPTION,CREDITO,DEBITO,FECHA,STAT,TIPO,LOTE,ENTITY_ID, CURRENCY_ID) AS
SELECT
	CAST(WIP_ISSUE_DIST.WORKORDER_BASE_ID + '/' + WIP_ISSUE_DIST.WORKORDER_LOT_ID + '.' + WIP_ISSUE_DIST.WORKORDER_SPLIT_ID + '.' + WIP_ISSUE_DIST.WORKORDER_SUB_ID AS VARCHAR(500))
	+ ' ' + ISNULL((SELECT TOP 1 PART_ID FROM WORK_ORDER WHERE TYPE='W' AND BASE_ID=WIP_ISSUE_DIST.WORKORDER_BASE_ID AND LOT_ID=WIP_ISSUE_DIST.WORKORDER_LOT_ID AND SPLIT_ID=WIP_ISSUE_DIST.WORKORDER_SPLIT_ID AND SUB_ID='0'),'')
	+ ' ' + ISNULL((SELECT TOP 1 ID FROM PART WHERE ID=(SELECT TOP 1 PART_ID FROM WORK_ORDER WHERE TYPE='W' AND BASE_ID=WIP_ISSUE_DIST.WORKORDER_BASE_ID AND LOT_ID=WIP_ISSUE_DIST.WORKORDER_LOT_ID AND SPLIT_ID=WIP_ISSUE_DIST.WORKORDER_SPLIT_ID AND SUB_ID='0')),'')
    + ' ' + ISNULL((SELECT TOP 1 DESCRIPTION FROM PART WHERE ID=(SELECT TOP 1 PART_ID FROM WORK_ORDER WHERE TYPE='W' AND BASE_ID=WIP_ISSUE_DIST.WORKORDER_BASE_ID AND LOT_ID=WIP_ISSUE_DIST.WORKORDER_LOT_ID AND SPLIT_ID=WIP_ISSUE_DIST.WORKORDER_SPLIT_ID AND SUB_ID='0')),'')
	 AS OT, 
	GL_ACCOUNT_ID, 
	(SELECT TOP 1 DESCRIPTION FROM ACCOUNT WHERE  ID=GL_ACCOUNT_ID), 
	'CR' = CASE WHEN AMOUNT_TYPE = 'CR' THEN AMOUNT END, 'DR' = CASE WHEN AMOUNT_TYPE = 'DR' THEN AMOUNT END, 
	POSTING_DATE, 
	POSTING_STATUS, 
	(SELECT TOP 1 TYPE FROM  JOURNAL_BATCH WHERE ID = BATCH_ID),
	BATCH_ID,
	ENTITY_ID , 
	CURRENCY_ID
 FROM 	WIP_ISSUE_DIST WHERE (NOT (BATCH_ID IS NULL))
UNION ALL 
SELECT
	CAST(WORKORDER_BASE_ID + '/' + WORKORDER_LOT_ID + '.' + WORKORDER_SPLIT_ID + '.' + WORKORDER_SUB_ID AS VARCHAR(500))
	+ ' ' + ISNULL((SELECT TOP 1 PART_ID FROM WORK_ORDER WHERE TYPE='W' AND BASE_ID=WIP_RECEIPT_DIST.WORKORDER_BASE_ID AND LOT_ID=WIP_RECEIPT_DIST.WORKORDER_LOT_ID AND SPLIT_ID=WIP_RECEIPT_DIST.WORKORDER_SPLIT_ID AND SUB_ID='0'),'')
	+ ' ' + ISNULL((SELECT TOP 1 ID FROM PART WHERE ID=(SELECT TOP 1 PART_ID FROM WORK_ORDER WHERE TYPE='W' AND BASE_ID=WIP_RECEIPT_DIST.WORKORDER_BASE_ID AND LOT_ID=WIP_RECEIPT_DIST.WORKORDER_LOT_ID AND SPLIT_ID=WIP_RECEIPT_DIST.WORKORDER_SPLIT_ID AND SUB_ID='0')),'')
	+ ' ' + ISNULL((SELECT TOP 1 DESCRIPTION FROM PART WHERE ID=(SELECT TOP 1 PART_ID FROM WORK_ORDER WHERE TYPE='W' AND BASE_ID=WIP_RECEIPT_DIST.WORKORDER_BASE_ID AND LOT_ID=WIP_RECEIPT_DIST.WORKORDER_LOT_ID AND SPLIT_ID=WIP_RECEIPT_DIST.WORKORDER_SPLIT_ID AND SUB_ID='0')),'')
    AS OT, GL_ACCOUNT_ID, 
	(SELECT TOP 1 DESCRIPTION FROM ACCOUNT WHERE  ID=GL_ACCOUNT_ID), 
	'CR' = CASE WHEN AMOUNT_TYPE = 'CR' THEN AMOUNT END, 'DR' = CASE WHEN AMOUNT_TYPE = 'DR' THEN AMOUNT END, 
	POSTING_DATE, 
	POSTING_STATUS, 
	(SELECT TOP 1 TYPE FROM  JOURNAL_BATCH WHERE ID = BATCH_ID),
	BATCH_ID,
	ENTITY_ID ,
	CURRENCY_ID
FROM 	WIP_RECEIPT_DIST WHERE  (NOT (BATCH_ID IS NULL))
UNION ALL 
SELECT
	ISNULL(CUST_ORDER_ID,'') + ' - ' + ISNULL(PART_ID,'') + ' ' +
 	ISNULL((	SELECT TOP 1 ISNULL(CUSTOMER_ORDER.CUSTOMER_ID,'') + ' ' + ISNULL(CUSTOMER.NAME,'') FROM CUSTOMER_ORDER INNER JOIN CUSTOMER ON CUSTOMER_ORDER.CUSTOMER_ID = CUSTOMER.ID
	WHERE (CUSTOMER_ORDER.ID = SHIPMENT_DIST.CUST_ORDER_ID)),'')
    AS PEDIDO_ARTICULO, GL_ACCOUNT_ID, 
	(SELECT TOP 1 DESCRIPTION FROM ACCOUNT WHERE  ID=GL_ACCOUNT_ID), 
	'CR' = CASE WHEN AMOUNT_TYPE = 'CR' THEN AMOUNT END, 'DR' = CASE WHEN AMOUNT_TYPE = 'DR' THEN AMOUNT END, 
	POSTING_DATE, 
	POSTING_STATUS, 
	(SELECT TOP 1 TYPE FROM  JOURNAL_BATCH WHERE ID = BATCH_ID),
	BATCH_ID,
	ENTITY_ID ,
	CURRENCY_ID
FROM 	SHIPMENT_DIST WHERE  (NOT (BATCH_ID IS NULL))
UNION ALL 
SELECT
 	CAST(PURC_ORDER_ID AS VARCHAR(500))
+ ' ' + ISNULL(
(SELECT ISNULL(PURCHASE_ORDER.VENDOR_ID,'') + ' ' + ISNULL(VENDOR.NAME,'')
FROM PURCHASE_ORDER INNER JOIN VENDOR ON PURCHASE_ORDER.VENDOR_ID = VENDOR.ID
WHERE PURCHASE_ORDER.ID = PURCHASE_DIST.PURC_ORDER_ID),'')

     , GL_ACCOUNT_ID, 
	(SELECT TOP 1 DESCRIPTION FROM ACCOUNT WHERE  ID=GL_ACCOUNT_ID), 
	'CR' = CASE WHEN AMOUNT_TYPE = 'CR' THEN AMOUNT END, 'DR' = CASE WHEN AMOUNT_TYPE = 'DR' THEN AMOUNT END, 
	POSTING_DATE, 
	POSTING_STATUS, 
	(SELECT TOP 1 TYPE FROM  JOURNAL_BATCH WHERE ID = BATCH_ID),
	BATCH_ID,
	ENTITY_ID ,
	CURRENCY_ID
FROM 	PURCHASE_DIST WHERE  (NOT (BATCH_ID IS NULL))
UNION ALL  
SELECT
 	CAST(TRANSACTION_ID AS VARCHAR(500)) + ' ' +
ISNULL(
(SELECT ISNULL(PART.ID,'') + ' '+  ISNULL(PART.DESCRIPTION,'')
FROM         INVENTORY_TRANS INNER JOIN
                      PART ON INVENTORY_TRANS.PART_ID = PART.ID
WHERE INVENTORY_TRANS.TRANSACTION_ID = ADJUSTMENT_DIST.TRANSACTION_ID)
,'')
as A
, GL_ACCOUNT_ID, 
	(SELECT TOP 1 DESCRIPTION FROM ACCOUNT WHERE  ID=GL_ACCOUNT_ID), 
	'CR' = CASE WHEN AMOUNT_TYPE = 'CR' THEN AMOUNT END, 'DR' = CASE WHEN AMOUNT_TYPE = 'DR' THEN AMOUNT END, 	
	POSTING_DATE, 
	POSTING_STATUS, 
	(SELECT TOP 1 TYPE FROM  JOURNAL_BATCH WHERE ID = BATCH_ID),
	BATCH_ID,
	ENTITY_ID ,
	CURRENCY_ID
 FROM 	ADJUSTMENT_DIST WHERE  (NOT (BATCH_ID IS NULL))
 UNION ALL
SELECT
 	CAST(TRANSACTION_ID AS VARCHAR(500))
+ ' ' + 
ISNULL(
(SELECT EMPLOYEE_ID
FROM LABOR_TICKET
WHERE (TRANSACTION_ID = INDIRECT_DIST.TRANSACTION_ID)
),'') as AD

, GL_ACCOUNT_ID,
	(SELECT TOP 1 DESCRIPTION FROM ACCOUNT WHERE  ID=GL_ACCOUNT_ID), 
	'CR' = CASE WHEN AMOUNT_TYPE = 'CR' THEN AMOUNT END, 'DR' = CASE WHEN AMOUNT_TYPE = 'DR' THEN AMOUNT END, 
	POSTING_DATE, 
	POSTING_STATUS, 
	(SELECT TOP 1 TYPE FROM  JOURNAL_BATCH WHERE ID = BATCH_ID),
	BATCH_ID,
	ENTITY_ID ,
	CURRENCY_ID
FROM  	INDIRECT_DIST WHERE  (NOT (BATCH_ID IS NULL))
UNION ALL
  SELECT
 	CAST(VOUCHER_ID AS VARCHAR(500))
	+ ' ' +
	ISNULL
	(
		(SELECT TOP 1 ISNULL(PAYABLE.INVOICE_ID,'') + ' ' + ISNULL(VENDOR.ID,'')  + ' ' + ISNULL(VENDOR.NAME,'')
		FROM  PAYABLE INNER JOIN   VENDOR ON PAYABLE.VENDOR_ID = VENDOR.ID
		WHERE PAYABLE.VOUCHER_ID = PAYABLE_DIST.VOUCHER_ID)
	,''
	)
	as PD
	, GL_ACCOUNT_ID, 
		(SELECT TOP 1 DESCRIPTION FROM ACCOUNT WHERE  ID=GL_ACCOUNT_ID), 
		'CR' = CASE WHEN AMOUNT_TYPE = 'CR' THEN AMOUNT END, 'DR' = CASE WHEN AMOUNT_TYPE = 'DR' THEN AMOUNT END, 
		POSTING_DATE, 
		POSTING_STATUS, 
		(SELECT TOP 1 TYPE FROM  JOURNAL_BATCH WHERE ID = BATCH_ID),
		BATCH_ID,	
		ENTITY_ID ,
		CURRENCY_ID
	 FROM
 		PAYABLE_DIST WHERE (NOT (BATCH_ID IS NULL))
UNION ALL
 SELECT 
	BANK_ACCOUNT_ID + ' - ' + CAST(CONTROL_NO AS VARCHAR(500)) + ' ' +
ISNULL
(

(SELECT  TOP 1    ISNULL(CAST(CASH_DISBURSEMENT.CHECK_NO as varchar(50)), '') + ' ' + ISNULL(VENDOR.ID,'') + ' ' + ISNULL(VENDOR.NAME,'')
FROM         CASH_DISBURSEMENT INNER JOIN
                      VENDOR ON CASH_DISBURSEMENT.VENDOR_ID = VENDOR.ID
WHERE     (CASH_DISBURSEMENT.BANK_ACCOUNT_ID = CASH_DISBURSE_DIST.BANK_ACCOUNT_ID) AND (CASH_DISBURSEMENT.CONTROL_NO = CASH_DISBURSE_DIST.CONTROL_NO)
)
,
(SELECT  TOP 1 CASH_DISBURSEMENT.NAME
FROM         CASH_DISBURSEMENT 
WHERE     (CASH_DISBURSEMENT.BANK_ACCOUNT_ID = CASH_DISBURSE_DIST.BANK_ACCOUNT_ID) AND (CASH_DISBURSEMENT.CONTROL_NO = CASH_DISBURSE_DIST.CONTROL_NO)
)
)

AS BANCO_CONTROL, GL_ACCOUNT_ID,
	(SELECT TOP 1 DESCRIPTION FROM ACCOUNT WHERE  ID=GL_ACCOUNT_ID), 
	'CR' = CASE WHEN AMOUNT_TYPE = 'CR' THEN AMOUNT END, 'DR' = CASE WHEN AMOUNT_TYPE = 'DR' THEN AMOUNT END, 
	POSTING_DATE, 
	POSTING_STATUS, 
	(SELECT TOP 1 TYPE FROM  JOURNAL_BATCH WHERE ID = BATCH_ID),
	BATCH_ID,	
	ENTITY_ID ,
	CURRENCY_ID
 FROM
 	CASH_DISBURSE_DIST WHERE (NOT (BATCH_ID IS NULL))

 UNION ALL
 SELECT
ISNULL
(
(
SELECT  CUSTOMER.ID
FROM         RECEIVABLE INNER JOIN  CUSTOMER ON RECEIVABLE.CUSTOMER_ID = CUSTOMER.ID
WHERE     (RECEIVABLE.INVOICE_ID = RECEIVABLE_DIST.INVOICE_ID)
)
,'') + ' ' +
 	CAST(INVOICE_ID AS VARCHAR(500))
+ ' ' +
(
SELECT    ISNULL(CUSTOMER.NAME,'')
FROM         RECEIVABLE INNER JOIN  CUSTOMER ON RECEIVABLE.CUSTOMER_ID = CUSTOMER.ID
WHERE     (RECEIVABLE.INVOICE_ID = RECEIVABLE_DIST.INVOICE_ID)
)
, GL_ACCOUNT_ID,
	(SELECT TOP 1 DESCRIPTION FROM ACCOUNT WHERE  ID=GL_ACCOUNT_ID), 
	'CR' = CASE WHEN AMOUNT_TYPE = 'CR' THEN AMOUNT END, 'DR' = CASE WHEN AMOUNT_TYPE = 'DR' THEN AMOUNT END, 
	POSTING_DATE, 
	POSTING_STATUS, 
	(SELECT TOP 1 TYPE FROM  JOURNAL_BATCH WHERE ID = BATCH_ID),
	BATCH_ID,
	ENTITY_ID ,
	CURRENCY_ID
 FROM
	RECEIVABLE_DIST WHERE  (NOT (BATCH_ID IS NULL))
 UNION ALL 
SELECT
 	CAST(CUSTOMER_ID + ' - ' + CHECK_ID AS VARCHAR(500)) + ' ' +
ISNULL((
	SELECT TOP 1 NAME
	FROM CUSTOMER
	WHERE ID=CASH_RECEIPT_DIST.CUSTOMER_ID 
	
)
,'')

AS CHEQUE, GL_ACCOUNT_ID,
	(SELECT TOP 1 DESCRIPTION FROM ACCOUNT WHERE  ID=GL_ACCOUNT_ID), 
	'CR' = CASE WHEN AMOUNT_TYPE = 'CR' THEN AMOUNT END, 'DR' = CASE WHEN AMOUNT_TYPE = 'DR' THEN AMOUNT END, 
	POSTING_DATE, 
	POSTING_STATUS, 
	(SELECT TOP 1 TYPE FROM  JOURNAL_BATCH WHERE ID = BATCH_ID),
	BATCH_ID,
	ENTITY_ID ,
	CURRENCY_ID
FROM
 	CASH_RECEIPT_DIST   WHERE  (NOT (BATCH_ID IS NULL))
UNION ALL 
SELECT 
	CAST(BANK_ACCOUNT_ID + ' - ' + ADJUSTMENT_ID AS VARCHAR(500)) + ' ' +
ISNULL(
(
SELECT REFERENCE
FROM         BANK_ADJUSTMENT
WHERE     (BANK_ACCOUNT_ID = BANK_ADJ_DIST.BANK_ACCOUNT_ID) AND (ADJUSTMENT_ID = BANK_ADJ_DIST.ADJUSTMENT_ID)
)
,
''
)

AS BANCO_AJUSTE, GL_ACCOUNT_ID, 
	(SELECT TOP 1 DESCRIPTION FROM ACCOUNT WHERE  ID=GL_ACCOUNT_ID), 
	'CR' = CASE WHEN AMOUNT_TYPE = 'CR' THEN AMOUNT END, 'DR' = CASE WHEN AMOUNT_TYPE = 'DR' THEN AMOUNT END, 
	POSTING_DATE, 
	POSTING_STATUS, 
	(SELECT TOP 1 TYPE FROM  JOURNAL_BATCH WHERE ID = BATCH_ID),
	BATCH_ID,
	ENTITY_ID ,
	CURRENCY_ID
FROM 
	BANK_ADJ_DIST WHERE (NOT (BATCH_ID IS NULL))


UNION ALL

SELECT     'TR:' + ISNULL(CAST(GJ_DIST.GJ_ID AS VARCHAR(500)),'') + 
           ISNULL(GJ_LINE.REFERENCE,'') AS Expr1, GJ_DIST.GL_ACCOUNT_ID,
                          (SELECT     TOP (1) DESCRIPTION
                            FROM          ACCOUNT
                            WHERE      (ID = GJ_DIST.GL_ACCOUNT_ID)) AS Expr2, CASE WHEN AMOUNT_TYPE = 'CR' THEN GJ_LINE.CREDIT_AMOUNT END AS 'CR', 
                      CASE WHEN AMOUNT_TYPE = 'DR' THEN GJ_LINE.DEBIT_AMOUNT END AS 'DR', GJ_DIST.POSTING_DATE, GJ_DIST.POSTING_STATUS,
                          (SELECT     TOP (1) TYPE
                            FROM          JOURNAL_BATCH
                            WHERE      (ID = GJ_DIST.BATCH_ID)) AS Expr3, GJ_DIST.BATCH_ID, GJ_DIST.ENTITY_ID, GJ_DIST.CURRENCY_ID
FROM         GJ_DIST INNER JOIN GJ_LINE ON GJ_DIST.GJ_ID = GJ_LINE.GJ_ID AND GJ_DIST.GL_ACCOUNT_ID = GJ_LINE.GL_ACCOUNT_ID
WHERE     (NOT (GJ_DIST.BATCH_ID IS NULL))


UNION ALL 
SELECT 
	CAST(REVALUE_ID AS VARCHAR(500)), GL_ACCOUNT_ID, 
	(SELECT TOP 1 DESCRIPTION FROM ACCOUNT WHERE  ID=GL_ACCOUNT_ID), 
	'CR' = CASE WHEN AMOUNT_TYPE = 'CR' THEN AMOUNT END, 'DR' = CASE WHEN AMOUNT_TYPE = 'DR' THEN AMOUNT END, 
	POSTING_DATE, 
	POSTING_STATUS, 
	(SELECT TOP 1 TYPE FROM  JOURNAL_BATCH WHERE ID = BATCH_ID),
	BATCH_ID,	
	ENTITY_ID ,
	CURRENCY_ID
FROM 
	REVALUE_DIST WHERE  (NOT (BATCH_ID IS NULL))
GO
